﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour
{

    [SerializeField]private float ballSpeed =100;
    private bool started = false;

    private BroadcastEnd broadcaster;
    private bool gravity = false;

    private int currentHealth = 1000;
    private ScoreScript score = null;

    public Sprite HeavyBallImage = null;

    [SerializeField] private BallSound bs = null;

    // Start is called before the first frame update
  

    // Update is called once per frame
    void Update()
    {

    }

    private void FixedUpdate()
    {
        if (started && !gravity)
        {
            Vector2 unit = GetComponent<Rigidbody2D>().velocity.normalized;
            GetComponent<Rigidbody2D>().velocity = unit * ballSpeed;

           
        }
        if (transform.position.y < -5f)
            Destroy(gameObject);

    }

    private void OnCollisionEnter2D(Collision2D collision)
    {

        if (collision.gameObject.CompareTag("Zone"))
        {
            broadcaster.BroadcastEndMessage();
            //callendgame here.
            bs.PlayGameOverSound();
        }
        else
            bs.PlayBounceSound();
    }

    private void OnCollisionExit2D(Collision2D collision)
    {
        //Debug.Log("Touched " + collision.ToString());
        if (collision.gameObject.CompareTag("Brick"))
        {
            score.AddScore();
            Brick brick = collision.gameObject.GetComponent<Brick>();
            brick.TakeDamage(1);
            currentHealth--;
            if (currentHealth <= 0)
                Destroy(gameObject);
        }
    }

    public void Kick(Vector3 velocity, float speed, BroadcastEnd _broadcaster, bool _gravity, ScoreScript _score)
    {
        score = _score;
        if(_gravity)
            SetGravity();
        ballSpeed = speed;
        broadcaster = _broadcaster;
        GetComponent<Rigidbody2D>().velocity = velocity;
        started = true;
    }

    private void SetGravity()
    {
        //replace sprite
        SpriteRenderer renderer = GetComponent<SpriteRenderer>();
        renderer.sprite = HeavyBallImage;
        transform.localScale = new Vector3(1.5f, 1.5f, 0.0f);
        gravity = true;
        PhysicsMaterial2D bouncy = new PhysicsMaterial2D();
        bouncy.friction = 0;
        bouncy.bounciness = 1;
        Rigidbody2D rb = GetComponent<Rigidbody2D>();
        rb.gravityScale = 1f;
        currentHealth = 2;
        //set material

    }
}
