﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BrickSpawner : MonoBehaviour
{
    public GameObject Holder = null;
    public List<GameObject> Prefabs = new List<GameObject>();

    public float Tempo = 2.0f;
    public float Variance = .35f;
    public Timer SpawnDelay = new Timer();


    public Vector2 SpawnSpeedRange = new Vector2(0, 20);
    public Vector3 SpawnDir = new Vector3(-1, -1, 0);
    public float SpawnAngleRange = 45.0f;

    public Vector3 SpawnVec
    {
        get
        {
            float value = Random.Range(-SpawnAngleRange, SpawnAngleRange);
            Quaternion rot = Quaternion.AngleAxis(value, Vector3.forward);
            Vector3 vec = rot * SpawnDir.normalized;

            float speed = Random.Range(SpawnSpeedRange.x, SpawnSpeedRange.y);
            Vector3 result = vec * speed;

            return result;
        }
    }

    // Start is called before the first frame update
    void Start()
    {
    }

    // Update is called once per frame
    void FixedUpdate()
    {
        SpawnDelay.Tick(Time.fixedDeltaTime);

        if (SpawnDelay.Done)
        {
            SpawnBrick();
            ResetTimer();
        }
    }

    void SpawnBrick()
    {
        int index = Random.Range(0, Prefabs.Count);
        GameObject prefab = Prefabs[index];
        GameObject created = GameObject.Instantiate(prefab, Holder.transform);
        created.transform.position = transform.position;

        Brick brick = created.GetComponent<Brick>();
        if (brick != null)
        {
            brick.Rigid.rotation = Random.value * 360;
            brick.Kick(SpawnVec);
            brick.BroadcastMessage("OnSpawn", SendMessageOptions.DontRequireReceiver);
        }
    }

    void ResetTimer()
    {
        SpawnDelay.Reset(Random.Range(Tempo - Variance, Tempo + Variance));
    }
}
