﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ChargeBar : MonoBehaviour
{
    protected Animator _Animator = null;
    public Animator Animator
    {
        get
        {
            if (_Animator == null)
                _Animator = GetComponentInChildren<Animator>();

            return _Animator;
        }
    }

    private void Start()
    {
        Animator.SetFloat("Percent", 0);
    }

    public void SetPercent(float percent)
    {
        Animator.SetFloat("Percent", percent);
    }

    public void SetLook(Vector2 dir)
    {
        //transform.LookAt(transform.position + new Vector3(dir.x, dir.y, 0));
        transform.LookAt(transform.position - Vector3.forward, new Vector3(dir.x, dir.y, 0));
    }
}
