﻿using System;
using UnityEngine;

public class MoveUtil
{
    public static void ClampedHorizontalMovement(Rigidbody2D rigid, float speed, float max_speed, float throttle, float step)
    {
        float horizon = throttle;
        float delta = speed * step * horizon;

        float vel_added = Math.Abs(delta) * rigid.mass * step;
        float target_speed = Math.Abs(rigid.velocity.x) + vel_added;
        if (target_speed > max_speed)
        {
            delta *= max_speed / target_speed;
        }

        rigid.AddForce(new Vector2(delta, 0));
    }

    public static void BasicJump(Rigidbody2D rigid, float speed)
    {
        var vel = rigid.velocity;
        vel.y = Mathf.Max(vel.y, speed);
        rigid.velocity = vel;
    }
}
