﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class PlayerProbe : MonoBehaviour
{
    public enum PurposeID
    {
        Any,
        Foot,
        Hand,
    };

    public PurposeID Purpose;

    public List<Collider2D> Touching = new List<Collider2D>();

    protected Collider2D _Collider = null;
    public Collider2D Collider
    {
        get
        {
            if (_Collider == null)
                _Collider = GetComponent<Collider2D>();
            return _Collider;
        }
    }

    public static PlayerProbe Find(GameObject source, PurposeID purpose)
    {
        foreach (var probe in source.GetComponentsInChildren<PlayerProbe>())
        {
            if (probe.Purpose == purpose)
                return probe;
        }

        return null;
    }

    public void Update()
    {
        
    }

    public void Sweep()
    {
        for (int i = Touching.Count - 1; i >= 0; --i)
        {
            if (Touching[i] == null)
                Touching.RemoveAt(i);
        }
    }

    public void OnTriggerEnter2D(Collider2D collision)
    {
        if (!Touching.Contains(collision))
            Touching.Add(collision);
    }

    public void OnTriggerExit2D(Collider2D collision)
    {
        Touching.Remove(collision);
    }
}
