﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerSensor : MonoBehaviour
{
    public LayerMask Standable = new LayerMask();

    protected PlayerProbe _Foot = null;
    public PlayerProbe Foot
    {
        get
        {
            if (_Foot == null)
                _Foot = PlayerProbe.Find(gameObject, PlayerProbe.PurposeID.Foot);
            return _Foot;
        }
    }

    protected PlayerProbe _Hand = null;
    public PlayerProbe Hand
    {
        get
        {
            if (_Hand == null)
                _Hand = PlayerProbe.Find(gameObject, PlayerProbe.PurposeID.Hand);
            return _Hand;
        }
    }

    public bool IsOnGround
    {
        get
        {
            if (Foot == null)
                return false;

            if (Foot.Collider == null)
                return false;

            if (!Foot.Collider.IsTouchingLayers(Standable))
                return false;

            return true;
        }
    }

    public Brick GetBrick()
    {
        foreach (var collider in Hand.Touching)
        {
            Brick brick = collider.GetComponent<Brick>();
            if (brick != null)
            {
                return brick;
            }
        }

        return null;
    }
}
