﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class TimeScript : MonoBehaviour
{
    [SerializeField] private Text textObject;

    TimeKeeper _Keeper = null;
    TimeKeeper Keeper
    {
        get
        {
            if (_Keeper == null)
            {
                _Keeper = FindObjectOfType<TimeKeeper>();
            }

            return _Keeper;
        }
    }

    // Start is called before the first frame update
    void Start()
    {
        if (textObject == null)
            Debug.LogError("TimeScript: Default not set.");
    }

    // Update is called once per frame
    void Update()
    {
        int minutes = Keeper.Minutes;
        int seconds = Keeper.Seconds;
        textObject.text = "Time: <b>" + minutes.ToString("0") + ":" + seconds.ToString("00") + "</b>";
    }
}
