﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BrickSound : MonoBehaviour
{

    [SerializeField] private AudioClip[] clips;
    [SerializeField] private float speedForFullVolume = 5;

    private AudioSource ss = null;

    // Start is called before the first frame update

    private void Start()
    {
        ss = GetComponent<AudioSource>();
        if (ss == null)
            Debug.LogError("AuidioSource is null in BrickSound.");
    }

    public void PlayBrickOnBrickSound(float speed)
    {
        ss.volume = Mathf.Min(speed/speedForFullVolume, 1.0f);
        ss.clip = clips[0];
        ss.Play();
    }

    public void PlayDestructionSound()
    {
        ss.volume = 1f;
        ss.clip = clips[1];
        ss.Play();
    }

    public void PlayCrackSound()
    {
        ss.volume = 1f;

        ss.clip = clips[2];
        ss.Play();
    }

    public void PlayThrowSound()
    {
        ss.volume = 1f;

        ss.clip = clips[3];
        ss.Play();
    }

    public void PlayPickupSound()
    {
        ss.volume = 1f;

        ss.clip = clips[4];
        ss.Play();
    }

}
