﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ballSpawner : MonoBehaviour
{
    public List<GameObject> Prefabs = new List<GameObject>();

    [SerializeField]private float spawnTimer = 20;

    public Timer SpawnDelay = new Timer();


    public float spawnSpeed = 100;
    public Vector3 SpawnDir = new Vector3(-1, -1, 0);
    public float SpawnAngleRange = 45.0f;

    [SerializeField]private GameObject ballGroup;

    [SerializeField] private uint maxBalls = 1;

    [SerializeField] private ScoreScript score;
    [SerializeField] private BroadcastEnd broadcaster;

    public Vector3 SpawnVec
    {
        get
        {
            float value = Random.Range(-SpawnAngleRange, SpawnAngleRange);
            Quaternion rot = Quaternion.AngleAxis(value, Vector3.forward);
            Vector3 vec = rot * SpawnDir.normalized;

            float speed = spawnSpeed;
            Vector3 result = vec * speed;

            return result;
        }
    }


    void FixedUpdate()
    {
        SpawnDelay.Tick(Time.fixedDeltaTime);

        if (ballGroup.transform.childCount < maxBalls)
        {
            SpawnBall();
            ResetTimer();
        }

        if (SpawnDelay.Done)
        {
            maxBalls++;
        }


    }

    void SpawnBall()
    {
        int index = Random.Range(0, Prefabs.Count);
        GameObject prefab = Prefabs[index];
        GameObject created = GameObject.Instantiate(prefab, ballGroup.transform);
        created.transform.position = transform.position;

        bool grav;
        Ball ball = created.GetComponent<Ball>();
        if (Random.Range(0, 10) < 7)
            grav = false;
        else
            grav = true;

        if (ball != null)
        {
            ball.Kick(SpawnVec, spawnSpeed, broadcaster, grav,score);
        }
    }

    void ResetTimer()
    {
        SpawnDelay.Reset(spawnTimer);
    }
}
